'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactState = require('react-state');

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _Selectors = require('../utils/Selectors');

var _Selectors2 = _interopRequireDefault(_Selectors);

var _HyperResponsive = require('../utils/HyperResponsive');

var _HyperResponsive2 = _interopRequireDefault(_HyperResponsive);

var _Utils = require('../utils/Utils');

var _Utils2 = _interopRequireDefault(_Utils);

var _Debug = require('../utils/Debug');

var Debug = _interopRequireWildcard(_Debug);

var _Rectangle = require('../primitives/Rectangle');

var _Rectangle2 = _interopRequireDefault(_Rectangle);

var _Voronoi = require('../components/Voronoi');

var _Voronoi2 = _interopRequireDefault(_Voronoi);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
//


var debug = process.env.NODE_ENV === 'development';

var Chart = function (_Component) {
  _inherits(Chart, _Component);

  function Chart() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Chart);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Chart.__proto__ || Object.getPrototypeOf(Chart)).call.apply(_ref, [this].concat(args))), _this), _this.updateDataModel = function (props) {
      var data = props.data;
      var getSeries = props.getSeries,
          getDatums = props.getDatums,
          getLabel = props.getLabel,
          getSeriesID = props.getSeriesID,
          getPrimary = props.getPrimary,
          getSecondary = props.getSecondary,
          getR = props.getR,
          getPrimaryAxisID = props.getPrimaryAxisID,
          getSecondaryAxisID = props.getSecondaryAxisID;

      // Normalize getters

      getSeries = _Utils2.default.normalizePathGetter(getSeries);
      getDatums = _Utils2.default.normalizePathGetter(getDatums);
      getLabel = _Utils2.default.normalizePathGetter(getLabel);
      getSeriesID = _Utils2.default.normalizePathGetter(getSeriesID);
      getPrimary = _Utils2.default.normalizePathGetter(getPrimary);
      getSecondary = _Utils2.default.normalizePathGetter(getSecondary);
      getR = _Utils2.default.normalizePathGetter(getR);
      getPrimaryAxisID = _Utils2.default.normalizePathGetter(getPrimaryAxisID);
      getSecondaryAxisID = _Utils2.default.normalizePathGetter(getSecondaryAxisID);

      // Check for data
      if (!data) {
        if (debug) Debug.noData(_this);
        return;
      }

      // getSeries
      var series = getSeries(data);

      // Check for data
      if (!series) {
        if (debug) Debug.noData(_this);
        return;
      }

      // First access the data, and provide it to the context
      var preMaterializedData = series.map(function (s, seriesIndex) {
        var seriesID = getSeriesID(s, seriesIndex, data);
        var seriesLabel = getLabel(s, seriesIndex, data);
        var primaryAxisID = getPrimaryAxisID(s, seriesIndex, data);
        var secondaryAxisID = getSecondaryAxisID(s, seriesIndex, data);
        var series = {
          original: s,
          index: seriesIndex,
          id: seriesID,
          label: seriesLabel,
          primaryAxisID: primaryAxisID,
          secondaryAxisID: secondaryAxisID,
          datums: getDatums(s, seriesIndex, data).map(function (d, index) {
            return {
              originalSeries: s,
              seriesIndex: seriesIndex,
              seriesID: seriesID,
              seriesLabel: seriesLabel,
              index: index,
              original: d,
              primary: getPrimary(d, index, s, seriesIndex, data),
              secondary: getSecondary(d, index, s, seriesIndex, data),
              r: getR(d, index, s, seriesIndex, data)
            };
          })
        };
        return series;
      });

      // Provide the preMaterializedData to the chart instance
      _this.props.dispatch(function (state) {
        return _extends({}, state, {
          preMaterializedData: preMaterializedData
        });
      }, {
        type: 'preMaterializedData'
      });
    }, _this.measure = function (prevProps) {
      if (!_this.el) {
        return;
      }
      _this.dims = _this.el.getBoundingClientRect();

      if (prevProps && (_this.props.offset.left !== prevProps.offset.left || _this.props.offset.top !== prevProps.offset.top)) {
        _this.props.dispatch(function (state) {
          return _extends({}, state, {
            offset: {
              left: _this.el.offsetLeft,
              top: _this.el.offsetTop
            }
          });
        }, {
          type: 'offset'
        });
      }
    }, _this.onMouseMove = _Utils2.default.throttle(function (e) {
      var clientX = e.clientX,
          clientY = e.clientY;
      var _this$props = _this.props,
          gridX = _this$props.gridX,
          gridY = _this$props.gridY,
          dispatch = _this$props.dispatch;


      dispatch(function (state) {
        var x = clientX - _this.dims.left - gridX;
        var y = clientY - _this.dims.top - gridY;

        var pointer = _extends({}, state.pointer, {
          active: true,
          x: x,
          y: y,
          dragging: state.pointer && state.pointer.down
        });
        return _extends({}, state, {
          pointer: pointer
        });
      }, {
        type: 'pointer'
      });
    }), _this.onMouseLeave = function () {
      var dispatch = _this.props.dispatch;

      dispatch(function (state) {
        return _extends({}, state, {
          pointer: _extends({}, state.pointer, {
            active: false
          }),
          hovered: _extends({}, state.hovered, {
            active: false
          })
        });
      }, {
        type: 'pointer'
      });
    }, _this.onMouseDown = function () {
      var dispatch = _this.props.dispatch;


      document.addEventListener('mouseup', _this.onMouseUp);
      document.addEventListener('mousemove', _this.onMouseMove);

      dispatch(function (state) {
        return _extends({}, state, {
          pointer: _extends({}, state.pointer, {
            sourceX: state.pointer.x,
            sourceY: state.pointer.y,
            down: true
          })
        });
      }, {
        type: 'pointer'
      });
    }, _this.onMouseUp = function () {
      var dispatch = _this.props.dispatch;


      document.removeEventListener('mouseup', _this.onMouseUp);
      document.removeEventListener('mousemove', _this.onMouseMove);

      dispatch(function (state) {
        return _extends({}, state, {
          pointer: _extends({}, state.pointer, {
            down: false,
            dragging: false,
            released: {
              x: state.pointer.x,
              y: state.pointer.y
            }
          })
        });
      }, {
        type: 'pointer'
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Chart, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          interaction = _props.interaction,
          hoverMode = _props.hoverMode,
          groupMode = _props.groupMode,
          showVoronoi = _props.showVoronoi,
          dispatch = _props.dispatch;

      if (interaction) {
        dispatch(function (state) {
          return _extends({}, state, {
            interaction: interaction
          });
        }, {
          type: 'interaction'
        });
      }
      if (hoverMode) {
        dispatch(function (state) {
          return _extends({}, state, {
            hoverMode: hoverMode
          });
        }, {
          type: 'hoverMode'
        });
      }
      if (groupMode) {
        dispatch(function (state) {
          return _extends({}, state, {
            groupMode: groupMode
          });
        }, {
          type: 'groupMode'
        });
      }
      if (showVoronoi) {
        dispatch(function (state) {
          return _extends({}, state, {
            showVoronoi: showVoronoi
          });
        }, {
          type: 'showVoronoi'
        });
      }
      this.updateDataModel(this.props);
      this.componentDidUpdate();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // If anything related to the data model changes, update it
      if (nextProps.interaction !== this.props.interaction) {
        this.props.dispatch(function (state) {
          return _extends({}, state, {
            interaction: nextProps.interaction
          });
        }, {
          type: 'interaction'
        });
      }

      if (nextProps.hoverMode !== this.props.hoverMode) {
        this.props.dispatch(function (state) {
          return _extends({}, state, {
            hoverMode: nextProps.hoverMode
          });
        }, {
          type: 'hoverMode'
        });
      }
      if (nextProps.groupMode !== this.props.groupMode) {
        this.props.dispatch(function (state) {
          return _extends({}, state, {
            groupMode: nextProps.groupMode
          });
        }, {
          type: 'groupMode'
        });
      }
      if (nextProps.showVoronoi !== this.props.showVoronoi) {
        this.props.dispatch(function (state) {
          return _extends({}, state, {
            showVoronoi: nextProps.showVoronoi
          });
        }, {
          type: 'showVoronoi'
        });
      }

      if (_Utils2.default.shallowCompare(this.props, nextProps, ['data', 'width', 'height'])) {
        this.updateDataModel(nextProps);
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      (0, _raf2.default)(function () {
        return _this2.measure(prevProps);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          style = _props2.style,
          width = _props2.width,
          height = _props2.height,
          handleRef = _props2.handleRef,
          gridX = _props2.gridX,
          gridY = _props2.gridY,
          children = _props2.children;


      var allChildren = _react2.default.Children.toArray(children);
      var svgChildren = allChildren.filter(function (d) {
        return !d.type.isHtml;
      });
      var htmlChildren = allChildren.filter(function (d) {
        return d.type.isHtml;
      });

      return _react2.default.createElement(
        'div',
        {
          ref: handleRef,
          className: 'ReactChart',
          style: {
            width: width,
            height: height,
            position: 'relative'
          }
        },
        _react2.default.createElement(
          'svg',
          {
            ref: function ref(el) {
              _this3.el = el;
            },
            style: _extends({
              width: width,
              height: height,
              overflow: 'hidden'
            }, style)
          },
          _react2.default.createElement(
            'g',
            {
              onMouseEnter: function onMouseEnter(e) {
                e.persist();
                _this3.onMouseMove(e);
              },
              onMouseMove: function onMouseMove(e) {
                e.persist();
                _this3.onMouseMove(e);
              },
              onMouseLeave: this.onMouseLeave,
              onMouseDown: this.onMouseDown,
              style: {
                transform: 'translate3d(' + (gridX || 0) + 'px, ' + (gridY || 0) + 'px, 0)'
              }
            },
            _react2.default.createElement(_Rectangle2.default
            // This is to ensure the pointer always has something to hit
            , { x1: -gridX,
              x2: width - gridX,
              y1: -gridY,
              y2: height - gridY,
              style: {
                opacity: 0
              }
            }),
            _react2.default.createElement(_Voronoi2.default, null),
            svgChildren
          )
        ),
        htmlChildren
      );
    }
  }]);

  return Chart;
}(_react.Component);

Chart.defaultProps = {
  getSeries: function getSeries(d) {
    return d;
  },
  getDatums: function getDatums(d) {
    return _Utils2.default.isArray(d) ? d : d.datums || d.data;
  },
  getLabel: function getLabel(d, i) {
    return d.label || 'Series ' + (i + 1);
  },
  getSeriesID: function getSeriesID(d, i) {
    return i;
  },
  getPrimary: function getPrimary(d) {
    return _Utils2.default.isArray(d) ? d[0] : d.primary || d.x;
  },
  getSecondary: function getSecondary(d) {
    return _Utils2.default.isArray(d) ? d[1] : d.secondary || d.y;
  },
  getR: function getR(d) {
    return _Utils2.default.isArray(d) ? d[2] : d.radius || d.r;
  },
  getPrimaryAxisID: function getPrimaryAxisID(s) {
    return s.primaryAxisID;
  },
  getSecondaryAxisID: function getSecondaryAxisID(s) {
    return s.secondaryAxisID;
  },
  onHover: function onHover() {},
  interaction: null,
  hoverMode: 'primary',
  groupMode: 'primary',
  showVoronoi: false
};


var ReactChart = (0, _reactState.Connect)(function () {
  var selectors = {
    gridWidth: _Selectors2.default.gridWidth(),
    gridHeight: _Selectors2.default.gridHeight(),
    gridX: _Selectors2.default.gridX(),
    gridY: _Selectors2.default.gridY(),
    offset: _Selectors2.default.offset()
  };
  return function (state) {
    return {
      data: state.data,
      width: state.width,
      height: state.height,
      active: state.active,
      selected: state.selected,
      gridWidth: selectors.gridWidth(state),
      gridHeight: selectors.gridHeight(state),
      gridX: selectors.gridX(state),
      gridY: selectors.gridY(state),
      offset: selectors.offset(state)
    };
  };
}, {
  pure: false
  // filter: (oldState, newState, meta) => meta.type !== 'pointer',
})(Chart);

var ProvidedChart = (0, _reactState.Provider)(ReactChart, {
  initial: {
    hovered: {
      active: false,
      series: null,
      datums: []
    },
    cursors: {},
    axes: {},
    pointer: {},
    tooltip: {},
    axisDimensions: {}
  }
});

exports.default = function (props) {
  return _react2.default.createElement(_HyperResponsive2.default, {
    render: function render(_ref2) {
      var handleRef = _ref2.handleRef,
          width = _ref2.width,
          height = _ref2.height;
      return _react2.default.createElement(ProvidedChart, _extends({}, props, { width: width, height: height, handleRef: handleRef }));
    }
  });
};