'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = makeContext;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defualtSubscribe = function defualtSubscribe(state) {
  return state;
};
var defaultMiddleware = function defaultMiddleware(_ref) {
  var action = _ref.action,
      setState = _ref.setState;
  return new Promise(function (resolve) {
    return setState(action, resolve);
  });
};
var globalDefaultProps = {
  name: 'NewContext',
  initialState: {},
  middleware: defaultMiddleware
};

function makeContext(userDefaultProps) {
  var Context = _react2.default.createContext({});

  var defaultProps = _extends({}, globalDefaultProps, userDefaultProps);

  var Provider = function (_React$Component) {
    _inherits(Provider, _React$Component);

    function Provider(props) {
      _classCallCheck(this, Provider);

      var _this = _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props));

      _this.safeSetState = function () {
        return _this.setState.apply(_this, arguments);
      };

      _this.setContext = function (action) {
        return _this.props.middleware({
          action: action,
          setState: _this.safeSetState,
          state: _this.state,
          props: _this.props
        });
      };

      _this.state = _extends({}, _this.props.initialState, {
        setContext: _this.setContext // eslint-disable-line
      });
      return _this;
    }

    _createClass(Provider, [{
      key: 'render',
      value: function render() {
        return _react2.default.createElement(
          Context.Provider,
          { value: this.state },
          this.props.children
        );
      }
    }]);

    return Provider;
  }(_react2.default.Component);

  Provider.defaultProps = defaultProps;
  Provider.displayName = '' + defaultProps.displayName;


  var withProvider = function withProvider(providerOpts) {
    return function (Component) {
      return function (props) {
        return _react2.default.createElement(
          Context.Provider,
          providerOpts,
          _react2.default.createElement(Component, props)
        );
      };
    };
  };

  var Consumer = function Consumer(_ref2) {
    var _ref2$subscribe = _ref2.subscribe,
        subscribe = _ref2$subscribe === undefined ? defualtSubscribe : _ref2$subscribe,
        render = _ref2.render,
        children = _ref2.children;
    return _react2.default.createElement(
      Context.Consumer,
      null,
      function (_ref3) {
        var setContext = _ref3.setContext,
            state = _objectWithoutProperties(_ref3, ['setContext']);

        return (render || children)(_extends({}, subscribe(state), { setContext: setContext }));
      }
    );
  };

  var withConsumer = function withConsumer() {
    var subscribe = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defualtSubscribe;
    return function (Component) {
      return function (props) {
        return _react2.default.createElement(
          Context.Consumer,
          null,
          function (_ref4) {
            var setContext = _ref4.setContext,
                state = _objectWithoutProperties(_ref4, ['setContext']);

            return _react2.default.createElement(Component, _extends({}, props, subscribe(state, props), { setContext: setContext }));
          }
        );
      };
    };
  };

  return {
    Provider: Provider,
    withProvider: withProvider,
    Consumer: Consumer,
    withConsumer: withConsumer
  };
}

// Usage

// // Make a new context with default props
// const { Provider, Consumer, withConsumer } = makeContext({
//   displayName: 'Todos',
//   initialState: {
//     todos: [],
//   },
// })

// // You can use selectors
// const selectTodos = state => ({ todos: state.todos })

// // Render-prop style
// const OnTheFlyTodos = () => (
//   <Consumer subscribe={selectTodos} render={({ todos }) => <div>{todos}</div>} />
// )
// // HOC style
// const HocTodos = withConsumer(selectTodos)(({ todos }) => <div>{todos}</div>)
// // Pure HOC style
// const PureTodos = withConsumer(selectTodos)(
//   class extends React.PureComponent {
//     render () {
//       const { todos } = this.props
//       return <div>{todos}</div>
//     }
//   }
// )

// const App = (
//   <Provider
//     // You can optionally override the initial state on the Provider
//     initialState={{
//       todos: [],
//     }}
//     // You can optionally override the middleware on the Provider
//     middleware={({
//  action, setState, state, props,
// }) => {
//       /* */
//     }}
//   >
//     <div>
//       <OnTheFlyTodos />
//       <HocTodos />
//       <PureTodos />
//     </div>
//   </Provider>
// )